PRO HDF_SD_VARREAD, HDFID, VARNAME, DATA, _EXTRA=EXTRA_KEYWORDS

;- Check arguments
if n_elements(hdfid) eq 0 then message, 'HDFID is undefined'
if n_elements(varname) eq 0 then message, 'VARNAME is undefined'
if arg_present(data) eq 0 then message, 'DATA cannot be modified'

;- Get the SDS index
index = hdf_sd_nametoindex(hdfid, varname)
if index lt 0 then begin
  text = string(varname, format='("Variable ", a, " was not found")')
  message, text, /continue
  return
endif

;- Get the data
varid = hdf_sd_select(hdfid, index)
hdf_sd_getdata, varid, data, _extra=extra_keywords
hdf_sd_endaccess, varid

END
