FUNCTION HIS_DECLARE_FILE_STRUCTURE

rcs_id = "$Id: his_declare_file_structure.pro,v 1.2 1998/07/24 18:10:46 gumley Exp $"

;+
; Purpose:
;    Create a structure in the HIS aircraft data record format.
;
; Created:
;    27-Jan-1995 PvD
;
; Modified:
;    23-Apr-1995 PvD - Converted to a function that returns a structure.
;
; Output:
;    his_record    A structure in HIS aircraft data record format.
;-

;- Define 100 (4 byte) word header HIS record structure

his_record = { his_record, $
                 record_number : 0.0, $
                 channel : 0.0, $
                 mirror_position : 0.0, $
                 scan_direction : 0.0, $
                 num_bad_mirror_alignment_records : 0.0, $
                 buffer_overflow : 0.0, $
                 num_unknown_records : 0.0, $
                 num_ifg_points : 0.0, $
                 start_record_number : 0.0, $
                 zpd_record_number : 0.0, $
                 time_secs : 0.0, $
                 hbb_temp_c : 0.0, $
                 cbb_temp_c : 0.0, $
                 dc_level_ch : fltarr(3), $              ; ( ch1, ch2, ch3 )
                 year : 0.0, month : 0.0, day : 0.0, $
                 ifg_zpd_0_flag :0.0, $
                 ifg_burst_noise_flag : 0.0, $
                 phase_std_dev : 0.0, $
                 begin_time : 0.0, $
                 current_time : 0.0, $
                 ifg_short_flag : 0.0, $
                 data_conv_type : 0.0, $
                 zpd_word_num : 0.0, $
                 time_correction : 0.0, $
                 apodisation : 0.0, $
                 num_ifg_pts_in_fft : 0.0, $
                 num_spectral_pts : 0.0, $
                 cal_record_1 : 0.0, $
                 delta_v : 0.0, $
                 v_start : 0.0, v_end : 0.0, $
                 num_32_bit_words_per_record : 0.0, $
                 num_header_words : 0.0, $
                 spectral_resolution : 0.0, $
                 bad_record_count_flag : 0.0, $
                 num_records_in_file : 0.0, $
                 avg_bb_temp : fltarr(2,2), $          ; ( bb_type, cal_pt )
                 cal_record_number : fltarr(2), $      ; ( cal_pt ) 
                 num_records_in_ifg : 0.0, $
                 qc_flag : 0.0, $
                 missing_ch_flag : 0.0, $
                 laser_wavenumber : 0.0, $
                 aircraft_data : fltarr(4), $          ; ( lat, lon, alt, hdng )
                 bb_temp_corr_coeffs : fltarr(3,2), $  ; ( coeff, bb_type )
                 avg_hk_temps : fltarr(12), $
                 avg_pressure : 0.0, $
                 avg_dc_level_ch : fltarr(3), $        ; ( ch1, ch2, ch3 )
                 avg_dewar_temp : fltarr(2), $         ; ( sample )
                 num_bad_bb_temps : fltarr(2), $       ; ( bb_type ) 
                 dummy : fltarr(10), $
                 bb_temp_stats : fltarr(2,2,2), $      ; ( stat_type, bb_type, sample )
                 ref_phase_std_dev : 0.0, $
                 max_delay : 0.0, $
                 data : fltarr(2050) }

return, his_record

END

