PRO MAS_UW_READ_QUICK, FILE, BAND, IMAGE, TIME, NSCANS

rcs_id = "$Id: mas_uw_read_quick.pro,v 1.2 1998/07/24 18:18:22 gumley Exp $"

;- open file and get number of complete scans

openr, lun, file, /get_lun
result = fstat( lun )
nscans = long( result.size ) / 74200L
npixels = 716
nwords = 742

;- check scan number to see if data is byte swapped

swap = 0
test = lonarr( 2 )
readu, lun, test
point_lun, lun, 0L
if test( 1 ) lt 0L or test( 1 ) gt 270000L then swap = 1

;- check whether file is band-interleaved by checking the band number

interleave = 0
data = intarr( nwords, 2 )
readu, lun, data
point_lun, lun, 0L
if swap then data = swap_endian( temporary( data ) )
if data( 15, 0 ) eq data( 15, 1 ) then interleave = 1

;- create MAS record structure

mas_record = { status:0, offset:0, scanline:0L, date:0L, $
  bb1temp:0, bb2temp:0, scanrate:0, hours:0, minutes:0, $
  seconds:0, heading:0, altitude:0, gain:0, band:0, time:0L, $
  bb1count:0, bb2count:0, roll:0, nadirlat:0L, nadirlon:0L, $
  video:intarr( npixels ), headtemp:0 }

;- create data array

data = replicate( mas_record, nscans / 8 + 1 )

;- read data from disk

case interleave of

  0 : begin
    scan = replicate( mas_record, 1 )
    n = 0L
    start = ( band - 1 ) * 2L * 742L
    point_lun, lun, start
    while not eof( lun ) do begin
	readu, lun, scan
	data( n ) = scan
	n = n + 1
	point_lun, lun, start + n * 8L * 74200L
    endwhile
  end
  
  1 : begin
    scan = replicate( mas_record, 1 )
    n = 0L
    start = ( band - 1 ) * 2L * 742L * nscans
    point_lun, lun, start
    for i = 0, nscans / 8 do begin
	readu, lun, scan
	data( n ) = scan
	n = n + 1
	point_lun, lun, start + n * 8L * 2L * 742L
    endfor
  end
  
endcase  
  
;- close data file

free_lun, lun

;- swap data if necessary

if swap then data = swap_endian( temporary( data ) )

;- extract image

image = data.video

;- subtract blackbody counts to remove gain variation

bb1c = data.bb1count
image = temporary( image ) - $
  temporary( rebin( rotate( bb1c, 1 ), 716, nscans / 8 + 1 ) )

;- resample image to quicklook size

image = congrid( temporary( image ), 179, nscans / 4 )

;- extract time

hour = data.hours
minute = data.minutes
second = data.seconds / 10
time = hour * 10000L + minute * 100L + second
time = congrid( temporary( time ), nscans )

END
