FUNCTION SETINTERSECTION, A, B

;+
; PURPOSE:
;    Compute the intersection of two sets of integers.
;
; INPUT:
;    A         Array of positive integers
;    B         Array of positive integers
;
; OUTPUT:
;    RESULT    Array of intersecting array indexes
;              (returns -1 if the arrays do not intersect)
; REVISED:
; Liam.Gumley@ssec.wisc.edu (originaly by RSI)
; $Id: setintersection.pro,v 1.1 1999/10/21 16:48:36 gumley Exp $
;-

;- Get ranges

minab = min(a, max=maxa) > min(b, max=maxb)
maxab = maxa < maxb

;- If either set is empty, or their ranges don't intersect, return

if maxab lt minab or maxab lt 0 then return, -1

;- Compute histogram

r = where((histogram(a, min=minab, max=maxab) ne 0) and  $
          (histogram(b, min=minab, max=maxab) ne 0), count)
if count eq 0 then return, -1 else return, r + minab

END

