;##############################################################################

PRO SHARP_HIS_EVENT, EVENT

@sharp.inc

;- Get info structure

widget_control, event.top, get_uvalue = top
widget_control, top, get_uvalue = pointer
pointer_value, pointer, info, /no_copy

;- Get user value from widget causing event

widget_control, event.id, get_uvalue = uvalue

;- Check possible events

case uvalue of 

  'File' : begin

    path = dialog_inputfile( path = info.his_directory, group = event.top, filter = "*.ame", $
      /must_exist, title = 'HIS File Selection', get_path = directory )

    if path ne '' then begin
    
      widget_control, event.top, hourglass = 1

      ;- Read HIS times

      his_read, path, info.date, his_time
      
      if his_time( 0 ) ne -1 then begin
      
        ;- Update file label
        
        widget_control, info.his_label, set_value = path
        
        ;- Update info structure

        info.his_flag = 1
        info.his_path = path
        info.his_directory = directory
        info.his_number = n_elements( his_time )
        info.his_time( 0 : info.his_number - 1 ) = temporary( his_time )
        
        ;- Update the image

        sharp_plot_update_draw, info
        
      endif

      widget_control, event.top, hourglass = 0

    endif    
    
  end

endcase

;- Update info structure

pointer_value, pointer, info, /set, /no_copy

END

;##############################################################################

PRO SHARP_HIS_DISMISS, EVENT

;- Kill the widget (which causes the cleanup routine to be called)

widget_control, event.top, map = 0
widget_control, event.top, /destroy

END

;##############################################################################

PRO SHARP_HIS_CLEANUP, ID

;- Get id of top level widget, and return if invalid
;- (this happens when the top level widget is destroyed)

widget_control, id, get_uvalue = top
if not widget_info( top, /valid_id ) then return

;- Get info structure

widget_control, top, get_uvalue = pointer
pointer_value, pointer, info, /no_copy

;- Set HIS flag off

if ( not info.mask_flag ) and ( not info.plot_flag ) then $
  widget_control, info.map_button, sensitive = 1
widget_control, info.his_button, sensitive = 1
info.his_flag = 0

;- Update image

sharp_plot_update_draw, info

;- Update info structure

pointer_value, pointer, info, /set, /no_copy

END

;##############################################################################

PRO SHARP_HIS, TOP, GROUP = GROUP, XOFFSET = XOFFSET, YOFFSET = YOFFSET

rcs_id = "$Id: sharp_his.pro,v 1.9 1999/11/16 18:04:05 gumley Exp $"

@sharp.inc

;- Get info structure

widget_control, top, get_uvalue = pointer
pointer_value, pointer, info, /no_copy

;- Check keywords

if not keyword_set( group ) then group = top
device, get_screen_size = sz
if not keyword_set( xoffset ) then xoffset = sz( 0 ) / 2
if not keyword_set( yoffset ) then yoffset = sz( 1 ) / 2

;- Create base widget

tlb = widget_base( group = group, column = 1, $
  uvalue = 'HIS_TLB', title = 'HIS', $
  xoffset = xoffset, yoffset = yoffset )
infobase = tlb

;- Create menu widgets

base = widget_base( tlb, /row, /frame )
butt = widget_button( base, value = 'File', uvalue = 'File', xsize = 55 )
butt = widget_button( base, value = 'Dismiss', uvalue = 'Dismiss', xsize = 55, $
  event_pro = 'sharp_his_dismiss' )
base = widget_base( tlb, /row )
string = info.his_path
if string eq " " then string = "(No HIS file selected)"
label = widget_label( base, value = string, xsize = 300, /align_left )

;- Realize widgets

widget_control, tlb, /realize

;- Update image

if info.his_path ne " " then sharp_plot_update_draw, info

;- Update info structure

info.his_base = tlb
info.his_label = label

;- Restore info structure

pointer_value, pointer, info, /set, /no_copy

;- Store top level base id of caller

widget_control, infobase, set_uvalue = top

;- Start event manager

xmanager, "sharp_his", tlb, cleanup = 'sharp_his_cleanup'

END

;##############################################################################
