PRO SHARP_LOCATE, TOP, GROUP=GROUP, XOFFSET=XOFFSET, YOFFSET=YOFFSET

rcs_id = "$Id: sharp_locate.pro,v 1.1 1999/10/21 19:48:20 gumley Exp $"

@sharp.inc

;- Check keywords

if n_elements(group) eq 0 then group=top
device, get_screen_size=sz
if n_elements(xoffset) eq 0 then xoffset = sz[0] / 2
if n_elements(yoffset) eq 0 then yoffset = sz[1] / 2

;- Get info structure

widget_control, top, get_uvalue = pointer
pointer_value, pointer, main_info, /no_copy

;- Turn on hourglass

widget_control, top, hourglass=1

;- Get lat/lon arrays for this file

path = main_info.path
hdfid = hdf_sd_start(path)
hdf_sd_varread, hdfid, 'PixelLatitude', lat
hdf_sd_varread, hdfid, 'PixelLongitude', lon
hdf_sd_end, hdfid

;- Create base widget

tlb = widget_base(/column, title='Locate', $
  group=group, xoffset=xoffset, yoffset=yoffset)
infobase = tlb

;- Create widgets

base = widget_base(tlb, /row)
text = widget_text(base, uvalue='Text')
butt = widget_button(base, uvalue='Browse', value='Browse')
draw = widget_draw(tlb, xsize=300, ysize=300)
text = widget_text(tlb, ysize=10, scr_ysize=200, /scroll)

;- Realize widgets

widget_control, tlb, /realize

;- Turn off hourglass

widget_control, top, hourglass=0

;- Create and store information structure

info = { lat:lat, $
         lon:lon, $
         slat:-999.9, $
         slon:-999.9, $
         latmin:latmin, $
         latmax:latmax, $
         lonmin:lonmin, $
         lonmax:lonmax, $
         latid:latid, $
         lonid:lonid, $
         statid:statid, $
         search_button:search_button }
widget_control, tlb, set_uvalue=info, /no_copy

;- Restore info structure

pointer_value, pointer, info, /set, /no_copy

;- Store top level base id of caller

widget_control, infobase, set_uvalue = top


;- Manage events

;xmanager, 'sharp_locate', tlb, cleanup='sharp_locate_cleanup'

END
