;##############################################################################

PRO SHARP_PLOT_UPDATE_DRAW, INFO, REGION = REGION

rcs_id = "$Id: sharp_plot_update_draw.pro,v 1.4 1999/06/10 16:41:08 gumley Exp $"

@sharp.inc

if not keyword_set( region ) then region = [ 0.0, 0.0, 1.0, 1.0 ]

;- define 10 graphics colors

colors
colors = [ 5, 4, 6, 1, 2, 3, 14, 9, 10, 15 ]

;- restore the image from the pixmap

if !d.name ne "PS" then begin
  wset, info.draw_window
  source = info.draw_pixmap
  if info.mask_flag and info.mask_path ne " " and info.mask_toggle then begin
    source = info.mask_pixmap  
    if info.mask_toggle1 then source = info.mask_pixmap1
  endif
  device, copy = [ 0, 0, draw_xsize, draw_ysize, 0, 0, source ]
endif

;- update plot regions in draw window

if info.plot_flag then begin

  thick = 2.0
  if !d.name eq 'PS' then thick = 5.0

  for i = 0, 9 do begin

    pointer_value, info.region_ptr( i ), region_data, /no_copy

    if region_data.result( 0 ) ne -1 then begin

      ;- draw the boundary for this region

	x = [ region_data.xvertices, region_data.xvertices( 0 ) ] / float( draw_xsize )
	y = [ region_data.yvertices, region_data.yvertices( 0 ) ] / float( draw_ysize )
	p = convert_region( x, y, region )
	n = n_elements( p )
	plots, p( 0 : n/2-1 ), p( n/2 : * ), /normal, color = colors( i ), $
        thick = thick

      ;- label the region
      
      xyouts, p(0) + 0.005, p(n/2) + 0.005, strcompress( i + 1, /remove_all ), $
        /normal, color = colors(i)

      ;- mark the centroid of this region

	x = [ region_data.x_centroid ] / float( draw_xsize )
	y = [ region_data.y_centroid ] / float( draw_ysize )
	p = convert_region( x, y, region )
	plots, p(0), p(1), /normal, color = colors( i ), psym = 1, thick = thick, symsize = 1.5
              
    endif

    pointer_value, info.region_ptr( i ), region_data, /set, /no_copy

  endfor

endif

;- update HIS FOV markers in the draw window

if info.his_flag then begin

  thick = 2.0
  if !d.name eq 'PS' then thick = 5.0

  ;- get HIS times within the MAS scene
  
  his_time = info.his_time( 0 : info.his_number - 1 )
  loc = where( his_time ge info.time1 and his_time le info.time2, count )

  his_color = 9
  
  if count ge 1 then begin

    his_time = his_time( loc )
    for i = 0, n_elements( his_time ) - 1 do begin
      loc = where( info.time eq his_time( i ), count )
      if count ge 1 then begin
        x = 357 / float( draw_xsize )
        y = loc( 0 ) / float( draw_ysize )
        p = convert_region( x, y, region )
        plots, p(0), p(1), /normal, psym = 1, symsize = 2, $
          color = his_color, thick = thick
        xyouts, p(0) + 0.025, p(1) - 0.005, $
          'HIS ' + strcompress( his_time( i ), /remove_all ), $
          /normal, color = his_color, charsize = 1.5
      endif
    endfor
    
  endif

endif

END

