;##############################################################################

PRO SHARP_ZOOM_EVENT, EVENT

@sharp.inc

;- get info structure

widget_control, event.top, get_uvalue = top
widget_control, top, get_uvalue = pointer
pointer_value, pointer, info, /no_copy

;- get user value from widget causing event

widget_control, event.id, get_uvalue = uvalue
help, uvalue

;- check possible events

case uvalue of

  'TLB' : if event.enter eq 1 then begin
    main_base = info.main_base
    pointer_value, pointer, info, /set, /no_copy
    widget_control, main_base, event_pro = 'sharp_event'
    return
  end

  'PLOT_TLB' : if event.enter eq 1 then begin
    plot_base = info.plot_base
    pointer_value, pointer, info, /set, /no_copy
    widget_control, plot_base, event_pro = 'sharp_plot_event'
    return
  end

  'MASK_TLB' : if event.enter eq 1 then begin
    mask_base = info.mask_base
    pointer_value, pointer, info, /set, /no_copy
    widget_control, mask_base, event_pro = 'sharp_mask_event'
    return
  end

  'HIS_TLB' : if event.enter eq 1 then begin
    his_base = info.his_base
    pointer_value, pointer, info, /set, /no_copy
    widget_control, his_base, event_pro = 'sharp_his_event'
    return
  end

  'ZOOM_TLB' : if event.enter eq 1 then begin
    zoom_base = info.zoom_base
    pointer_value, pointer, info, /set, /no_copy
    widget_control, zoom_base, event_pro = 'sharp_zoom_event'
    return
  end

  else : print, uvalue
    
end

;- update info structure

pointer_value, pointer, info, /set, /no_copy

END

;##############################################################################

PRO SHARP_ZOOM_DISMISS, EVENT

;- Kill the widget (which causes the cleanup routine to be called)

widget_control, event.top, map = 0
widget_control, event.top, /destroy

END

;##############################################################################

PRO SHARP_ZOOM_CLEANUP, ID

;- Get id of top level widget, and return if invalid
;- (this happens when the top level widget is destroyed)

widget_control, id, get_uvalue = top
if not widget_info( top, /valid_id ) then return

;- Get info structure

widget_control, top, get_uvalue = pointer
pointer_value, pointer, info, /no_copy

;- Set zoom off

widget_control, info.zoom_button, sensitive = 1
info.zoom_flag = 0

;- Update info structure

pointer_value, pointer, info, /set, /no_copy

END

;##############################################################################

PRO SHARP_ZOOM, TOP, GROUP = GROUP, XOFFSET = XOFFSET, YOFFSET = YOFFSET

rcs_id = "$Id: sharp_zoom.pro,v 1.6 1999/06/10 18:57:47 gumley Exp $"

@sharp.inc

;- get info structure

widget_control, top, get_uvalue = pointer
pointer_value, pointer, info, /no_copy

;- check keywords

if not keyword_set( group ) then group = top
device, get_screen_size = sz
if not keyword_set( xoffset ) then xoffset = sz( 0 ) / 2
if not keyword_set( yoffset ) then yoffset = sz( 1 ) / 2

;- create base widget

tlb = widget_base( group = group, column = 1, $
  uvalue = 'ZOOM_TLB', title = 'Zoom', $
  xoffset = xoffset, yoffset = yoffset )
infobase = tlb

;- create menu widgets

base = widget_base( tlb, /row, /frame )
butt = widget_button( base, value = 'Dismiss', uvalue = 'Dismiss', xsize = 60, $
  event_pro = 'sharp_zoom_dismiss' )

;- create draw widget

draw = widget_draw( tlb, xsize = info.zoom_xsize - 1, ysize = info.zoom_ysize - 1 )

;- realize widgets

widget_control, tlb, /realize

;- update info structure

info.zoom_base = tlb
widget_control, draw, get_value = wid
info.zoom_window = wid

;- restore info structure

pointer_value, pointer, info, /set, /no_copy

;- store top level base id of caller

widget_control, infobase, set_uvalue = top

;- start event manager

xmanager, "sharp_zoom", tlb, cleanup = 'sharp_zoom_cleanup'

end

;##############################################################################
