PRO UPDATE_PIXEL_VALUE, EVENT, INFO

rcs_id = "$Id: update_pixel_value.pro,v 1.8 1999/09/14 19:48:12 gumley Exp $"

;- get cursor x/y location in draw window

x = event.x
y = event.y

;- if cursor is on the image, update the pixel values displayed

if x ge 0 and x le 715 and y ge 0 and y le 715 then begin

  text = string( x, y, 715 - x, info.scanline( y ), info.time( y ), $
    info.map_lat( x, y ), info.map_lon( x, y ), info.image( x, y ), $
    format = '( "Pixel:", i3, "  Line:", i3, "  Sample:", i3, "  Scanline:", i6, "  Time:", i6.6,' + $
    '"  Lat:", f8.3, "  Lon:", f9.3, "  Value:", f8.3 )' )
    
  if info.rgb_flag then begin
    text = string( x, y, 715 - x, info.scanline( y ), info.time( y ), $
      info.map_lat( x, y ), info.map_lon( x, y ), info.rgb_image( *, x, y ), $
      format = '( "Pixel:", i3, "  Line:", i3, "  Sample:", i3, "  Scanline:", i6, "  Time:", i6.6,' + $
      '"  Lat:", f8.3, "  Lon:", f9.3, "  Value:", f8.3, ",", f8.3, ",", f8.3 )' )
  endif  
  
  string = string( info.band, format = '( "Band ", i2.2 )' )
  if info.band eq 99 then string = info.title
  widget_control, info.text, set_value = string + "  " + text

endif

;- Get depth of current display

device, get_visual_depth=depth

;- if cursor is on the image and zoom window exists, then update zoom image

if x ge 0 and x le 715 and y ge 0 and y le 715 and info.zoom_flag then begin

  ;- get edges of region to extract from image

  dx = ( 0.5 * info.zoom_xsize ) / float( info.zoom_factor )
  dy = ( 0.5 * info.zoom_ysize ) / float( info.zoom_factor )
  x0 = ( ( x - dx ) > 0 ) < ( 715 - 2*dx )
  y0 = ( ( y - dy ) > 0 ) < ( 715 - 2*dy )
  nx = 2 * dx
  ny = 2 * dy
  
  ;- read region from draw window, zoom it, and display in zoom window

  wset, info.draw_window
  xsize  = nx * info.zoom_factor
  ysize  = ny * info.zoom_factor

  if depth le 8 then begin
    region = safe_tvrd(x0, y0, nx, ny)
    region = rebin(temporary(region), xsize, ysize, /sample)
    wset, info.zoom_window
    tv, temporary(region)
  endif else begin
    region = safe_tvrd(x0, y0, nx, ny, true=1)
    region = rebin(temporary(region), 3, xsize, ysize, /sample)
    wset, info.zoom_window
    tv, temporary(region), true=1
  endelse

  ;- overlay crosshair on zoom image (empty call added to flush graphics output)

  xoffset = ( x - x0 ) * info.zoom_factor
  yoffset = ( y - y0 ) * info.zoom_factor
  plots, [ 0, nx*info.zoom_factor - 1 ], [ yoffset, yoffset ], /device, color = 5
  plots, [ xoffset, xoffset ], [ 0, ny*info.zoom_factor - 1 ], /device, color = 5
  empty
    
endif
    
END
